function initMozlessPrefs() {
  document.getElementById("prefMozlessClear").checked = false;

	{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

  document.getElementById("prefMozlessEnabled").checked
    = mozless_getBoolPref(prefs, "enabled", true);
  document.getElementById("prefMozlessDebug").checked
    = mozless_getBoolPref(prefs, "debug", false);
  document.getElementById("prefMozlessFocusMode").checked
    = mozless_getBoolPref(prefs, "focusmode", false);
  document.getElementById("prefMozlessEmacsKeys").checked
		= mozless_getBoolPref(prefs, "emacskeys", false);
	}

/*
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);

		document.getElementById("prefMozlessTypeaheadfindAutostart").checked
			= mozless_getBoolPref(prefs, "accessibility.typeaheadfind.autostart",
			prefs.getBoolPref("accessibility.typeaheadfind.autostart"));
		document.getElementById("prefMozlessTypeaheadfindLinksonly").checked
			= mozless_getBoolPref(prefs, "accessibility.typeaheadfind.linksonly",
			prefs.getBoolPref("accessibility.typeaheadfind.linksonly"));
	}
*/
}

function mozless_getBoolPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getBoolPref(name);
	else
		return d;
}

function mozless_getIntPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getIntPref(name);
	else
		return d;
}

function mozless_getCharPref(prefs, name, d)
{
	if (prefs.prefHasUserValue(name))
		return prefs.getCharPref(name);
	else
		return d;
}

function mozless_getAppName()
{
	var name = null;

	try {
		var info = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
		name = info.name;
	} catch (e) { }

	return name;
}

function changeMozlessPrefs() {
	if (document.getElementById("prefMozlessClear").checked) {
		clearMozlessPrefs();
		mozless_settings_clear_typeaheadfind();
	} else {
		updateMozlessPrefs();
		if (!document.getElementById("prefMozlessEnabled").checked)
			mozless_settings_clear_typeaheadfind();
		else
			mozless_settings_update_typeaheadfind();
	}
}

function updateMozlessPrefs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

	prefs.setBoolPref("enabled",
		document.getElementById("prefMozlessEnabled").checked);
	prefs.setBoolPref("debug",
		document.getElementById("prefMozlessDebug").checked);
	prefs.setBoolPref("focusmode",
		document.getElementById("prefMozlessFocusMode").checked);
	prefs.setBoolPref("emacskeys", 
		document.getElementById("prefMozlessEmacsKeys").checked);
}

function clearMozlessPrefs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("extensions.mozless.");

	try {
		prefs.clearUserPref("enabled");
	} catch (e) { }
	try {
		prefs.clearUserPref("debug");
	} catch (e) { }
	try {
		prefs.clearUserPref("focusmode");
	} catch (e) { }
	try {
		prefs.clearUserPref("emacskeys");
	} catch (e) { }
}

function mozless_settings_update_typeaheadfind()
{
/*
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("");

	var b;

	b = document.getElementById("prefMozlessTypeaheadfindAutostart").checked;
	if (b != prefs.getBoolPref("accessibility.typeaheadfind.autostart"))
		prefs.setBoolPref("accessibility.typeaheadfind.autostart", b);
	b = document.getElementById("prefMozlessTypeaheadfindLinksonly").checked;
	if (b != prefs.getBoolPref("accessibility.typeaheadfind.linksonly"))
		prefs.setBoolPref("accessibility.typeaheadfind.linksonly", b);
*/
}

function mozless_settings_clear_typeaheadfind()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"]
		.getService(Components.interfaces.nsIPrefBranch);

	var autostart = prefs.getBoolPref("accessibility.typeaheadfind.autostart");
	var linksonly = prefs.getBoolPref("accessibility.typeaheadfind.linksonly");

	try {
		prefs.clearUserPref("accessibility.typeaheadfind.autostart");
	} catch (e) { }
	try {
		prefs.clearUserPref("accessibility.typeaheadfind.linksonly");
	} catch (e) { }

	if (prefs.getBoolPref("accessibility.typeaheadfind.autostart") != autostart)
		if (mozless_getAppName() != "Firefox")
			alert("Auto Start in Type Ahead Find has been cleared."
				+ " (accessibility.typeaheadfind.autostart = default)");
	if (prefs.getBoolPref("accessibility.typeaheadfind.linksonly") != linksonly)
		alert("Links Only in Type Ahead Find has been cleared."
			+ " (accessibility.typeaheadfind.linksonly = default)");
}
